/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription, StringFunctionTypes } from './general';

export const StringFunctions: Record<StringFunctionTypes, GeneralDescription<StringFunctionTypes>> = {
  // [StringFunctionTypes.CONCAT]: {
  //   key: 'stringFunctionConcat',
  //   name: 'Concat',
  //   type: StringFunctionTypes.CONCAT,
  //   description: 'Lowercase all characters',
  //   numInputs: 1,
  //   inputs: [{ name: '1', type: 'string', default: '' }],
  //   output: { name: 'lower_case', type: 'string' },
  //   logic: ['Lower', '@i'],
  // },
  [StringFunctionTypes.LOWER]: {
    key: 'stringFunctionLowerCase',
    name: 'Lower Case',
    type: StringFunctionTypes.LOWER,
    description: 'Lowercase all characters',
    input: { name: 'Value', type: 'string', default: '' },
    numExtraInputs: 0,
    inputs: [],
    output: { name: 'lower_case', type: 'string' },
    logic: ['Lower', '@i'],
  },
  [StringFunctionTypes.UPPER]: {
    key: 'stringFunctionUpperCase',
    name: 'Upper Case',
    type: StringFunctionTypes.UPPER,
    description: 'Uppercase all characters',
    input: { name: 'Value', type: 'string', default: '' },
    numExtraInputs: 0,
    inputs: [],
    output: { name: 'upper_case', type: 'string' },
    logic: ['Upper', '@i'],
  },
};

/** All available functions in the function bar. */
export const StringFunctionArray: Array<GeneralDescription<StringFunctionTypes>> = Object.values(StringFunctions);
